

library("PoiClaClu")
library("sSeq")
source("classnb.R")
source("CountDataSet1.R")
source("GetDnb.R")


#------ Generating simulated data -------------

truephi = 1  ## param değeri

dat <- CountDataSet1(n=40, p=200, sdsignal=5, K=2, param=1/truephi, drate=0.3)


#------ Computing the dispersion using sSeq -------------

X = t(dat$x)  ## DESeq mantığı ile veri matrisi
tt = getT(X, sizeFactors=rep(1,ncol(X)))$target  ## shrinkage parametresinin hesaplandığı kısım.

rM = rowMeans(X); ## gene means
rV = rowVars(X); # gene variances

disp = (rV - rM)/rM^2
disp0=numeric()

for(i in 1:length(disp)){
 a1=0;a2=disp[i];
 disp0[i]=max(a1,a2)
}

disperhat = getAdjustDisp(disp0, shrinkTarget=tt)$adj


#------ Classification using NBLDA -------------

out = classnb(dat$x, dat$y, dat$xte, type = "deseq")
out$ytehat


#------ E N D -------------



