
combine <- function(input=NULL, output=NULL){
  
  if (is.null(input)){input = getwd()}
  setwd(input)
  folders = dir()
  nf = length(folders)
  
  if (is.null(output)){
    path = getwd()
    dir.create(paste(path,"/Combined",sep=""))
    output = paste(path,"/Combined",sep="")
  }
  
  TestRes = TrainRes = TuneParam = NULL
  
  for (i in 1:nf){
    setwd(paste(input,"/",folders[i],sep=""))
    load("CVResults.rda")
    load("TestResults.rda")
    #load("TuneParameters.rda")
    
    for(ind in 1:length(ResultTest.rpt)){
      for(j in 1:4){
        tmpTest = ResultTest.rpt[[ind]][[j]] 
        TestRes = rbind(TestRes, tmpTest)
        
        tmpTrainCV = ResultTrainCV.rpt[[ind]][[j]] 
        TrainRes = rbind(TrainRes, tmpTrainCV)
      }
    }
  }

  setwd(output)
  save(TestRes,file="ResultTest.rpt_ALL")
  save(TrainRes,file="ResultTrainCV.rpt_ALL")
}

inputVST = "/home/dncr/Dropbox/GSD/Studies/CLASSIFICATION OF RNA-SEQ DATA VIA BAGGING SUPPORT VECTOR MACHINES/Simulasyon/BMC Revision/Results/VST/"
outputVST = "/home/dncr/Dropbox/GSD/Studies/CLASSIFICATION OF RNA-SEQ DATA VIA BAGGING SUPPORT VECTOR MACHINES/Simulasyon/BMC Revision/Results/Birlestirilmis/VST"

inputRLOG = "/home/dncr/Dropbox/GSD/Studies/CLASSIFICATION OF RNA-SEQ DATA VIA BAGGING SUPPORT VECTOR MACHINES/Simulasyon/BMC Revision/Results/RLOG/"
outputRLOG = "/home/dncr/Dropbox/GSD/Studies/CLASSIFICATION OF RNA-SEQ DATA VIA BAGGING SUPPORT VECTOR MACHINES/Simulasyon/BMC Revision/Results/Birlestirilmis/RLOG/"

combine(inputVST, outputVST)
combine(inputRLOG, outputRLOG)

load(paste(outputVST, "/ResultTest.rpt_ALL", sep=""))
load(paste(output, "/ResultTrainCV.rpt_ALL", sep=""))
