

#### bagged svm sequential computation (debugging)
#baggedSVM2 <- function(tr, cl, ts = NULL, cl.ts = NULL, nFolds = 5, repeats = 10, B = 10, 
#                      m, combs.sub, foldIdx = NULL, seed = NULL, ...){
library(DESeq2)
library(caret)
library(kernlab)
library(randomForest)
library(sSeq)
library(plyr)


source("baggAggregate.R")
source("foldIndex.R")

## Source codes of PLDA (Witten et. al.)
source("Classify.cv.R")
source("Classify.R")
source("CountDataSet.R")
source("FindBestTransform.R")
source("Functions.R")
source("NullModel.R")
source("NullModelTest.R")
source("PoissonDistance.R")

## Source codes of NBLDA
source("classnb.R")
source("CountDataSet1.R")
source("GetDnb.R")

wd = getwd()  ## working directory.

save = TRUE  ## save results.
continue = FALSE  ## elektrik kesintisi durum
m.last = 1  ## Bilgisayar??n kapanmas?? durumunda en son hangi noktada kald??????n?? g??steren indis.

B = 101
rpt = 10  ## number of repeat. (whole scenario)
repeats = 10; nFolds = 5

#ctrl <- trainControl(method = "repeatedcv", number=5, repeats = 10)
transform = "vst"   # vst veya rlog 

#n=c(80); p=50; kg=c(2); param=100; sdsignal=3; DE=.1; P.all=10000

n <- c(20,40,60,80)
p <- c(25,50,75,99)
kg <- c(2,3,4)
param <- c(100,10,1)  ## nbinom() fonksiyonunda 1/param olarak dikkate al??n??yor. dolay??s??yla, param (1,10,100)
sdsignal <- 3
DE = c(0.01, 0.05, 0.10)
P.all = 10000 ## Total number of features.

combs = expand.grid(n,kg,param,DE)  ## Olas?? kombinasyonlar?? tutan matris. Her bir kolonda ilgili vekt??r??n elemanlar??n?? sakl??yor. (data frame)
n.comb = dim(combs)[1]  ## number of possible combinations
id = 1:n.comb

combs = cbind(id,combs)
colnames(combs) = c("id","n","kg","param","DERate")

combs.sub = combs[1,]  ## Analiz edilecek kombinasyonlar belirleniyor.
n.comb.sub = dim(combs.sub)[1]  ## number of possible combinations of subset of combs


gokmencount<-function (n, p, K, param, sdsignal, DE = 0.3)
{
  if (n < 4 * K) 
    stop("We require n to be at least 4*K.")
  q0 <- rexp(p, rate = 1/25)
  isDE <- runif(p) < DE  ## %the probability of a gene to be differentially expressed.  DE = c(2, 10, 30)
  classk <- matrix(NA, nrow = K, ncol = p)
  for (k in 1:K) {
    lfc <- rnorm(p, sd = sdsignal)
    classk[k, ] <- ifelse(isDE, q0 * exp(lfc), q0)
  }
  truesf <- runif(n) * 2 + 0.2
  truesfte <- runif(n) * 2 + 0.2
  conds <- sample(c(rep(1:K, 4), sample(1:K, n - 4 * K, replace = TRUE)))
  condste <- sample(c(rep(1:K, 4), sample(1:K, n - 4 * K, replace = TRUE)))
  x <- xte <- matrix(NA, nrow = n, ncol = p)
  for (i in 1:n) {
    for (k in 1:K) {
      if (conds[i] == k) 
        x[i, ] <- rnbinom(p, mu = truesf[i] * classk[k,], size = param)
      if (condste[i] == k)
        xte[i, ] <- rnbinom(p, mu = truesfte[i] * classk[k,], size = param)
    }
  }
  rm <- apply(x, 2, sum) == 0
  y <- conds
  gok <- as.data.frame(cbind(x[, !rm],y))
  return(gok)
}


data <- NULL
dataexpTrain <- NULL

PLDAresultTest.rpt <- list()
ResultTest.rpt <- list()
ResultTrainCV.rpt <- list()

TuneParameters.rpt = list()
RAWdataSets.rpt = list()


if (continue) {
  load(file = paste(ifelse(transform == "rlog", "RLOG//", "VST//"), "TestResults.rda", sep = ""))
  load(file = paste(ifelse(transform == "rlog", "RLOG//", "VST//"), "CVResults.rda", sep = ""))
  load(file = paste(ifelse(transform == "rlog", "RLOG//", "VST//"), "TuneParameters.rda", sep = ""))
}

if (!continue) {m.last = 1}
m <- p.ind <- R <- 1

for (R in 1:20){
  print(paste("progress:  ", R, sep = ""))
  nCl.OK = FALSE
  
  while(!nCl.OK){
    data <- gokmencount(n=combs.sub[m,"n"], p=P.all, K=combs.sub[m,"kg"], 
                        param=combs.sub[m,"param"], sdsignal=sdsignal, DE = combs.sub[m,"DERate"])
    nCl.OK <- length(unique(data$y)) == combs.sub[m,"kg"]
  }
  
  trts.OK = FALSE
  while (!trts.OK){
    train.ind = sample(1:nrow(data), ceiling(0.70*nrow(data)), FALSE)
    test.ind = c(1:nrow(data))[-train.ind]
    train.raw = data[train.ind, ]
    test.raw = data[-train.ind, ]
    
    # train setindeki sÄ±nÄ±f sayÄ±sÄ±nÄ±n ilgili kombinasyondaki sÄ±nÄ±f sayÄ±sÄ± kadar olmasÄ± gerekiyor. 4 sÄ±nÄ±flÄ± bir
    # kombinasyonda Ã¼retilen veride yalnÄ±zca 1,2 ve 4 sÄ±nÄ±flarÄ± var ise verinin yeniden test / train olarak ayrÄ±lmasÄ± gerekiyor.
    ## Ã–nemli olan train kÃ¼mseinde istenilen sayÄ±da sÄ±nÄ±fÄ±n yer almasÄ±. Test setinde sÄ±nÄ±flardan bir tanesi yer almasa dahi
    # classifier'lar 4 sÄ±nÄ±fa gÃ¶re eÄŸitildiÄŸi iÃ§in sÄ±nÄ±flama performanslarÄ± bu durumdan olumsuz etkilenmeyecektir.
    trts.OK <- (length(unique(train.raw$y)) == combs.sub[m,"kg"])
  }
  
  nZ = nearZeroVar(train.raw[, -dim(train.raw)[2]])
  
  if(length(nZ) != 0){
    train.raw = train.raw[,-nZ]
    test.raw = test.raw[,-nZ]      
  }
  
  train.cond = train.raw[,dim(train.raw)[2]]
  test.cond = test.raw[,dim(train.raw)[2]]
  
  #############  DESeq2
  train.rawS4 = DESeqDataSetFromMatrix(countData = as.matrix(t(train.raw[, -dim(train.raw)[2]] + 1)), 
                                       colData = data.frame(factor(train.cond)), formula(~ 1))
  design(train.rawS4) = ~ 1
  dds = DESeq(train.rawS4, fitType=c("local"))
  res = results(dds)
  #resOrdered <- res[order(res$padj),]
  resOrdered <- res[order(res$stat, decreasing = TRUE),]
  feat.Selected = rownames(as.data.frame(resOrdered)[1:p[p.ind],])
  
  trPLDA <- tr <- train.raw[, feat.Selected]   ## PLDA'da do??rudan bu matrix kullan??lacak.
  tsPLDA <- ts <- test.raw[, feat.Selected]
  #trExp = dataexpTrain[, feat.Selected]
  #tsExp = 
  
  #################################
  
  tr = t(tr + 1)
  ts = t(ts + 1)
  
  #Calculation of test set size factors using geometric means from training data
  geomts = ts / exp(rowMeans(log(tr)))
  sizeF.ts = apply(geomts, 2, function(x) median(x))
  
  #deseq normalization and vst transformation to training data
  trS4 = DESeqDataSetFromMatrix(countData = as.matrix(tr), colData = data.frame(condition=factor(train.cond)), formula(~ 1))
  design(trS4) = ~ 1
  trS4 = estimateSizeFactors(trS4)
  trS4 = estimateDispersions(trS4, fitType=c("local"))
  
  if (transform == "vst"){
    trS4expVST = DESeq2:::varianceStabilizingTransformation(trS4, blind = FALSE)  ## DESeq2 ye g??re g??ncellenecek (yukar??dakiler)
    dataexpTrainVST = t(assay(trS4expVST))
  }
  
  if (transform == "rlog"){
    trS4expRLOG = rlog(trS4, blind = F)
    dataexpTrainRLOG = t(assay(trS4expRLOG))
    betaPriorVar = attr(trS4expRLOG,"betaPriorVar")
    intercept = mcols(trS4expRLOG)$rlogIntercept
  }
  
  #deseq normalization and vst transformation to test data
  tsS4 = DESeqDataSetFromMatrix(countData = as.matrix(ts), colData = data.frame(condition=factor(test.cond)), formula(~ 1))
  tsS4 = estimateSizeFactors(tsS4)
  sizeFactors(tsS4) = sizeF.ts    #Test set size factors are calculated above
  dispersionFunction(tsS4) = dispersionFunction(trS4)  ## Use dispersion parameters from training set
  mcols(tsS4)$dispFit <- mcols(trS4)$dispFit
  
  if (transform == "vst"){
    tsS4expVST = DESeq2:::varianceStabilizingTransformation(tsS4, blind = F)
    tsVST <- dataexpTestVST <- t(assay(tsS4expVST))
    trVST = dataexpTrainVST
  }
  
  if (transform == "rlog"){
    tsS4expRLOG = rlog(tsS4, blind = F, intercept=intercept, betaPriorVar=betaPriorVar)
    tsRLOG <- dataexpTestRLOG <- t(assay(tsS4expRLOG))
    trRLOG = dataexpTrainRLOG
  }
  
  #################################
  
  # tr.Param de??erleri expression verileri i??in uygulanacak.
  ######tr.ParamVST = list(Mean = colMeans(trVST), Std.Dev. = apply(trVST,2,sd))
  ######tr.ParamRLOG = list(Mean = colMeans(trRLOG), Std.Dev. = apply(trRLOG,2,sd))
  #trExp.Param = list(Mean = colMeans(trExp), Std.Dev. = apply(trExp,2,sd))
  
  ## Test set tr.Param de??erlerine g??re 
  ######tsVST = scale(tsVST, center = tr.ParamVST$Mean, scale = tr.ParamVST$Std.Dev.)
  ######tsRLOG = scale(tsRLOG, center = tr.ParamRLOG$Mean, scale = tr.ParamRLOG$Std.Dev.)
  
  if (transform == "vst") tr = trVST else tr = trRLOG
  if (transform == "vst") ts = tsVST else ts = tsRLOG
  
  fold.IdxOK = FALSE
  while (!fold.IdxOK){
    fold.Idx = foldIndex(tr, nFolds = nFolds, repeats = repeats)
    fold.Idx_In = fold.Idx$indexIn
    yfold.Idx_In = lapply(fold.Idx_In, FUN = function(x)as.factor(train.cond)[x])
    fold.IdxOK = all(ldply(lapply(yfold.Idx_In, FUN = function(x)length(unique(x)) == combs.sub[m,"kg"]))[,2])   
  }
  
  ctrl <- trainControl(method = "repeatedcv", number = nFolds, repeats = repeats,
                       index = fold.Idx$indexIn, indexOut = fold.Idx$indexOut)
  
  cl = train.cond; cl.ts = test.cond; foldIdx = fold.Idx; seed = NULL
  
  if(!is.null(seed)){set.seed(seed)}
  cl = as.factor(cl); 
  if(!is.null(cl.ts)){cl.ts = factor(cl.ts, levels = levels(cl))}
  
  nn = length(cl)
  foldAccuracy = NULL
  tsAccuracy = NULL
  
  for (rr in 1:repeats){
    ## indices of the samples in the folds.
    
    if (is.null(foldIdx)){
      yfoldsInOK = FALSE
      while (!yfoldsInOK){
        foldsIn = createFolds(1:nn, k = nFolds, list = TRUE, returnTrain = TRUE)
        foldsOut = lapply(foldsIn, function(x)c(1:nn)[-x])
        yfoldsIn = lapply(foldsIn, FUN = function(x)cl[x])
        yfoldsOut = lapply(foldsIn, FUN = function(x)cl[-x])
        
        yfoldsInOK = all(ldply(lapply(yfoldsIn, FUN = function(x)length(unique(x)) == combs.sub[m,"kg"]))[,2])
      }
    }
    
    if (!is.null(foldIdx)){
      tmpp = c(1, seq(nFolds, nFolds*repeats, by = 5) + 1)
      foldsIn = foldIdx$indexIn[tmpp[rr]:(tmpp[rr+1] - 1)]
      foldsOut = foldIdx$indexOut[tmpp[rr]:(tmpp[rr+1] - 1)]
      yfoldsIn = lapply(foldsIn, FUN = function(x)cl[x])
      yfoldsOut = lapply(foldsIn, FUN = function(x)cl[-x])
    }
    
    preds = factor(rep(NA, nn), levels = levels(cl))
    tsAccuracy.fold = NULL
    for (i in 1:length(foldsIn)){
      x = tr[foldsIn[[i]],]
      y = cl[foldsIn[[i]]]
      xts = tr[foldsOut[[i]],]
      yts = cl[foldsOut[[i]]]
      
      ctrl2 <- trainControl(method = "repeatedcv", number = 2, repeats = 2, allowParallel = FALSE)  ## Paralel kodlama foreach aÃ…Å¸amasÃ„Â±nda veriliyor.
      
      baggPred_Matrix = NULL
      for (b in 1:B){
        n2 = nrow(x)
        predictedSVM.B_ts = NULL
        
        BOOT.OK = FALSE
        while (!BOOT.OK){
          idx = sort(sample(n2, n2, TRUE))
          x.B = x[idx,]; y.B = y[idx]
          BOOT.OK <- (length(unique(y.B)) == combs.sub[m,"kg"])
        }
        
        modelSVM.B = try(train(x.B, as.factor(y.B), trControl=ctrl2, 
                               tuneLength = 5, method = "svmRadial"))
        
        predictedSVM.B = predict.train(modelSVM.B, newdata = xts)   ## prediction for fold-out samples
        
        if (!is.null(ts)){
          predictedSVM.B_ts = predict.train(modelSVM.B, newdata = ts)  ## prediction for independent test set
        }                 
        baggPred_Matrix = cbind(baggPred_Matrix, c(predictedSVM.B, predictedSVM.B_ts)) 
      }
      
      AggrBaggPred = factor(baggAgregate(baggPred_Matrix, levels = NULL), levels = levels(cl))  ## aggregated results for fold-out and independent test samples.
      predsFold.k = factor(AggrBaggPred[1:length(yts)], levels = levels(cl))    ## aggregated results for fold-out samples.    
      predTest.k = factor(AggrBaggPred[(length(yts) + 1):length(AggrBaggPred)], levels = levels(cl)) ## aggregated results for independent test samples.
      
      tsACC.k = sum(cl.ts == predTest.k) / length(predTest.k)
      tsAccuracy.fold = c(tsAccuracy.fold, tsACC.k )
      preds[foldsOut[[i]]] = predsFold.k
    }
    
    foldAccuracy.r = sum(preds == cl) / length(cl)
    foldAccuracy = c(foldAccuracy, foldAccuracy.r)
    tsAccuracy = c(tsAccuracy, mean(tsAccuracy.fold))
  }
  
  res = list(Fold.Accuracy.Train = foldAccuracy, OveralAccuracy.Train = mean(foldAccuracy), 
             Fold.Accuracy.Test = tsAccuracy, OveralAccuracy.Test = mean(tsAccuracy))
  
  #return(list(Fold.Accuracy.Train = foldAccuracy, OveralAccuracy.Train = mean(foldAccuracy), 
  #            Fold.Accuracy.Test = tsAccuracy, OveralAccuracy.Test = mean(tsAccuracy)))
  #}
  
  mylist = list(foldlar = foldIdx, x = x, y = y, xts = xts, yts = yts, baggPred_Matrix = baggPred_Matrix, model = modelSVM.B,
                x.B = x.B, y.B = y.B, tr = tr, ts = ts, train.cond = train.cond, test.cond = test.cond)
}

save(mylist, file = "saved.rda")