fitModel <- function(iter = 5, ...){
    error = TRUE
    i = 1
    while ((error) && (i < 5)){
       model <- try(train(...))
       error <- class(model) == "try-error"
       i = i + 1
    }
    if (i == iter) {
        model = NA
        warning("Algorithm did not converge. Returning NAs")
    }
    return(model)
}

predictModel <- function(model, newdata){
    if (class(model) == "train"){
        predicted = predict.train(model, newdata = newdata)    
        ts.acc = sum(test.cond == as.numeric(predicted)) / length(test.cond)
    }
    if (class(model) != "train"){ 
        ts.acc = NA
    }
    return(ts.acc)
}


