
foldIndex <- function(data, nFolds = 5, repeats = 2){
    n = nrow(data)
    indIn <- indOut <- list()
    
    for (j in 1:repeats){
        tmpIn = createFolds(1:n, k = nFolds, list = TRUE, returnTrain = TRUE)
        tmpOut = lapply(tmpIn, function(x)c(1:n)[-x])
        
        indIn = c(indIn, tmpIn)
        indOut = c(indOut, tmpOut)
    }
    
    nms = paste(rep(paste("Fold", 1:nFolds, sep = ""), repeats), 
                rep(paste(".Rep", 1:repeats, sep = ""), c(rep(nFolds, repeats))), sep = "")
    names(indIn) <- names(indOut) <- nms
    return(list(indexIn = indIn, indexOut = indOut))
}